//**********************************************************************
// File name: obj.h
//
//      Definition of CPDSvrObj
//
// Copyright (c) 1994 Microsoft Corporation. All rights reserved.
//**********************************************************************

#if !defined( _OBJ_H_)
#define _OBJ_H_

#include "..\idl\pd.h"  // generated by MIDL compiler

class CPDSvrApp ;

typedef struct  // record structure for database entries
{
    LPTSTR name;
    LPTSTR phone_number;
} record;

#define MAX_RECORDS 5

class CPDSvrObj : public ILookup
{
private:
	int m_nCount;                   // reference count
    CPDSvrApp FAR * m_lpApp ;     // pointer to app object so
				    // we can tell it when we've
				    // been destroyed.

	DWORD m_dwRegister;             // Registered in ROT

	record theDatabase[MAX_RECORDS];   // phone book

public:
    // IUnknown methods
	STDMETHODIMP QueryInterface (REFIID riid, LPVOID FAR* ppvObj);
	STDMETHODIMP_(ULONG) AddRef ();
	STDMETHODIMP_(ULONG) Release ();

	// IPhoneDir methods
	STDMETHODIMP LookupByName(LPTSTR lpName, TCHAR ** lplpNumber);
    STDMETHODIMP LookupByNumber(LPTSTR lpNumber, TCHAR ** lplpName);

// construction/destruction
	CPDSvrObj(CPDSvrApp FAR * lpApp);
	virtual ~CPDSvrObj();

// utility functions
	BOOL Initialize(void);
    void CreateRecord(int i,LPTSTR lpName,LPTSTR lpNumber);


};
#endif
